package MT::Plugin::CommentTree;
;#	MTCommentTree - Xbh`̃Rg\邽߂ MovableType vOC
;#	@see http://www.magicvox.net/archive/2005/08040004.php
;#			Programmed by Piroli YUKARINOMIYA
;#			Open MagicVox.net - http://www.magicvox.net
use strict;
use MT::Template::Context;

;# vOCo^
if (MT->can ('add_plugin')) {
	require MT::Plugin;
	my $plugin = MT::Plugin->new;
		$plugin->name ('MTCommentTree ver 0.15 (Release 221)');
		$plugin->description ('Enable to show the user comments like a tree type BBS.');
		$plugin->doc_link ('http://www.magicvox.net/archive/2005/08040004.php');
	MT->add_plugin ($plugin);
}

;# nho^
MT::Template::Context->add_container_tag (CommentTree => \&comment_tree);
MT::Template::Context->add_tag (CommentChildRecurse => \&comment_child_recurse);
MT::Template::Context->add_conditional_tag (CommentHasChild => \&comment_has_child);
MT::Template::Context->add_conditional_tag (CommentHasNoChild => \&comment_has_no_child);
MT::Template::Context->add_conditional_tag (CommentIsRoot => \&comment_is_root);



;### MTCommentTree
sub comment_tree {
	my ($ctx, $args, $cond) = @_;
;#
	my $e = $ctx->stash('entry')
			or return $ctx->_no_entry_error('MTCommentTree');
	my $comments = $e->comments;
	my $so = $args->{sort_order}
			|| $ctx->stash('blog')->sort_order_comments;
	my @comments = $so eq 'ascend' ?
			sort { $a->created_on <=> $b->created_on } @$comments :
			sort { $b->created_on <=> $a->created_on } @$comments;
	@comments = grep { $_->visible() } @comments;

	my $builder = $ctx->stash ('builder');
	my $tokens = $ctx->stash ('tokens');

	;# MTCommentChildRecurse ċAĂяô߂̑O
	$ctx->stash ('commentTreeTokens', $tokens);
	$ctx->stash ('commentTreeSortOrder', $so);

	my $parent_id = $ctx->stash ('commentParentID') || 0;

	my $html = '';
	my $i = 1;
	for my $c (@comments) {
		$c->url(0) unless defined $c->url;
		my ($my_parent) = $c->url =~ /\/?(\d+)$/;
		if (($my_parent || 0) == $parent_id) {
			$ctx->stash('comment' => $c);
			local $ctx->{current_timestamp} = $c->created_on;
			$ctx->stash('comment_order_num', $i);
			my $out = $builder->build ($ctx, $tokens, $cond);
			return $ctx->error ($builder->errstr)
					unless defined $out;
			$html .= $out;
		}
		$i++;
	}

	return $html;
}

;### MTCommentChildRecurse
sub comment_child_recurse {
	my ($ctx, $args) = @_;
;#
	my $e = $ctx->stash('entry')
			or return $ctx->_no_entry_error('MTCommentChildRecurse');
	my $comments = $e->comments;
	my $so = $ctx->stash ('commentTreeSortOrder')
			|| $ctx->stash('blog')->sort_order_comments;
	my @comments = $so eq 'ascend' ?
			sort { $a->created_on <=> $b->created_on } @$comments :
			sort { $b->created_on <=> $a->created_on } @$comments;
	@comments = grep { $_->visible() } @comments;

	;# g[N MTCommentTree ̂
	my $tokens = $ctx->stash ('commentTreeTokens')
			or return $ctx->error ("MTCommentChildRecurse used outside of MTCommentTree");
	my $builder = $ctx->stash ('builder');

	;# x͎eɂȂ
	my $me = $ctx->stash ('comment')
			or return ($ctx->_no_comment_error ('comment_child_recurse(1)'));
	my $parent_id = $me->id;
	$ctx->stash ('commentParentID', $parent_id);

	my $html = '';
	my $i = 1;
	for my $c (@comments) {
		$c->url(0) unless defined $c->url;
		my ($my_parent) = $c->url =~ /\/?(\d+)$/;
		if (($my_parent || 0) == $parent_id) {
			$ctx->stash('comment' => $c);
			local $ctx->{current_timestamp} = $c->created_on;
			$ctx->stash('comment_order_num', $i);
			my $out = $builder->build ($ctx, $tokens);
			return $ctx->error ($builder->errstr)
					unless defined $out;
			$html .= $out;
		}
		$i++;
	}
	;# ɖ߂
	$ctx->stash('comment' => $me);

	return $html;
}



;### MTCommentHasChild
sub comment_has_child {
    my ($ctx, $args, $cond) = @_;
;#
	;# ID
	my $me = $ctx->stash ('comment')
			or return ($ctx->_no_comment_error ('MTCommentHasChild - comment'));
	my $my_id = $me->id;

	;# ̃GgɂSẴRg
	my $entry = $ctx->stash ('entry')
			or return $ctx->_no_entry_error ('MTCommentHasChild - entry');
	my $comments = $entry->comments;

	;# IDeƂRg邩H
	for my $c (@$comments) {
		$c->url(0) unless defined $c->url;
		my ($my_parent) = $c->url =~ /\/?(\d+)$/;
		return 1 if ($my_parent || 0) == $my_id;
	}
	return 0;
}

;### MTCommentHasNoChild
sub comment_has_no_child {
    my ($ctx, $args, $cond) = @_;
;#
	;# ID
	my $me = $ctx->stash ('comment')
			or return ($ctx->_no_comment_error ('MTCommentHasNoChild - comment'));
	my $my_id = $me->id;

	;# ̃GgɂSẴRg
	my $entry = $ctx->stash ('entry')
			or return $ctx->_no_entry_error ('MTCommentHasNoChild - entry');
	my $comments = $entry->comments;

	;# IDeƂRg邩H
	for my $c (@$comments) {
		$c->url(0) unless defined $c->url;
		my ($my_parent) = $c->url =~ /\/?(\d+)$/;
		return 0 if ($my_parent || 0) == $my_id;
	}
	return 1;
}

;### MTCommentIsRoot
sub comment_is_root {
    my ($ctx, $args, $cond) = @_;
;#
	my $me = $ctx->stash ('comment')
			or return ($ctx->_no_comment_error ('MTCommentIsRoot - comment'));
	;# ɐeRgIDw肪邩H
	return 1 unless $me->url;
	my ($my_parent) = $me->url =~ /\/?(\d+)$/;
	return 1 unless (defined $my_parent && $my_parent);
	return 0;
}



1;
__END__
========================================================================
2006/02/21	0.15	$c->url  undefined ̎ɃRgĂ܂sC
2006/02/20	0.14	MTCommentIsRoot 삵ĂȂsC
2006/02/19	0.13	qRg̓tssC
2006/02/18	0.12	č\zɌxfĂsC
2005/08/07	0.11	č\zɌxfĂsC
2005/08/03	0.10	ŌJ
